% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

% ESERCIZIO 1.1: Un ESERCIZIO DI TRASFORMAZIONE 
% DI COORDINATE e TRA DIVERSI SISTEMI DI
% RIFERIMENTO


%% DATI
clear all, clc
%lambda_P=9, 13',39''.000;
lambda_P=(9+13/60+39/3600)/180*pi;
%phi_P=45,28',40''.000;
phi_P=(45+28/60+40/3600)/180*pi;
hp=163.00; %m
%alpha=27.2552;
alpha=27.2552/180*pi;
D=3001.342 ; %m
%xi=83.5626;
xi=83.5626/180*pi; 
%parametri ellissoide Hayford
a=6378388;%m
e_2=0.006722670022333;


%% CONVERSIONI DA COORDINATE POLARI A COORDINATE CARTESIANE LOCALI

cart_locQ(1,1)=D*sin(xi)*sin(alpha);
cart_locQ(2,1)=D*sin(xi)*cos(alpha);
cart_locQ(3,1)=D*cos(xi)+hp;

%% CONVERSIONI DA COORDINATE CARTESIANE LOCALI A COORDINATE CARTESIANE GEOCENTRICHE
%conversione coordinate geografiche di P in coordinate cartesiane
%geocentriche
Np=a/(1-e_2*(sin(phi_P))^2)^0.5; %m

cart_geocP(1,1)=Np*cos(phi_P)*cos(lambda_P);
cart_geocP(2,1)=Np*cos(phi_P)*sin(lambda_P);
cart_geocP(3,1)=Np*(1-e_2)*sin(phi_P);

%matriche di rotazione Rl_G=Rz*Ry*Rx
rx=-(pi/2-phi_P);
Rx=[1 0 0;
    0 cos(rx) sin(rx);
    0 -sin(rx) cos(rx)];

Ry=eye(3);
rz=-(pi/2+lambda_P);
Rz=[cos(rz) sin(rz) 0;
    -sin(rz) cos(rz) 0;
    0 0 1];

Rl_G=Rz*Ry*Rx;

%calcolo delle coordinate geocentriche di Q
%X_Q=X_P+Rl_G*xq
cart_geocQ=cart_geocP+Rl_G*cart_locQ;

%% TRSFORMAZIONE DA COORDIANTE COORDINATE CARTESIANE GEOCENTRICHE A COORDIANATE GEOGRAFICHE

P=sqrt(cart_geocQ(1,1)^2+cart_geocQ(2,1)^2);
e_2_1=e_2/(1-e_2);
b=a*sqrt(1-e_2);
psi=atan((cart_geocQ(3,1)*a)/(P*b));


lambda_Q=atan2(cart_geocQ(2,1),cart_geocQ(1,1));
phi_Q=atan((cart_geocQ(3,1)+e_2_1*b*sin(psi)^3)/(P-e_2*a*cos(psi)^3));
NQ=a/(1-e_2*(sin(phi_Q))^2)^0.5; %m
h=P/cos(phi_Q)-NQ;
%conversione angoli da radianti a gradi sessagesimali
phi_Q_d=phi_Q/pi*180;
phi_Q_s =[floor(phi_Q_d) floor((phi_Q_d-floor(phi_Q_d))*60) ((phi_Q_d-floor(phi_Q_d))*60-floor((phi_Q_d-floor(phi_Q_d))*60))*60];
clear phi_Q_d

%conversione angoli da radianti a gradi sessagesimali
lambda_Q_d=lambda_Q/pi*180;
lambda_Q_s =[floor(lambda_Q_d) floor((lambda_Q_d-floor(lambda_Q_d))*60) ((lambda_Q_d-floor(lambda_Q_d))*60-floor((lambda_Q_d-floor(lambda_Q_d))*60))*60];
clear phi_Q_d