% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

% ESERCIZIO 1.2: CALCOLO DELLA LUNGHEZZA
% DI UN ARCO DI PARALLELO E DI MERIDIANO

%% DATI
clear all, clc
%phi_P=45+33/60;
%phi_P1=45+33/60+1/3600;

%parametri ellissoide Hayford
a=6378388;%m
e_2=0.006722670022333;

%% CONVERSIONI MISURE ANGOLARI
%conversione delle misure angoli da gradi sessagesimali a radianti
phi_P=(45+33/60)/180*pi; %rad
phi_P1=(45+33/60+1/3600)/180*pi; %rad
delta_lamb=1/3600*pi/180;

%% CALCOLO DELL'ARCO DI PARALLELO
%calcolo della gran normale N
N=a/(1-e_2*(sin(phi_P))^2)^0.5; %m
%calcolo del raggio
r=N*cos(phi_P);
%calcolo dell'arco di parallelo
Lp=r*delta_lamb;

%% CALCOLO DELL'ARCO DI MERDIDIANO
%funzione da integrare
%si noti come  necessario utilizzare ./, .* o.^ poich si vuole applicare
%l'operazione elemento per elemento. Nel caso di calcoli matriciali infatti
%gli operandi /,*,^2 assumono il significato di operazioni matriciali (es.
%A*B = prodotto matriciale tra A e B
%A.*B = si esegue il prodotto elemento per elemento degli elementi
%contenuti nelle matrici A e B
fun = @(x) a*(1-e_2)./(1-e_2.*(sin(x)).^2).^1.5;
%formula di integrazione numerica
Lm = integral(fun,phi_P,phi_P1);