% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

% ESERCIZIO 1.3: TRASFORMAZIONE DA COORDINATE GEOGRAFICHE 
% A COORDINATE CARTESIANE GEOCENTRICHE PER IL CALCOLO 
% DELLA DISTANZA TRA DUE PUNTI

%% DATI
clear all, clc

%latitudine del punto A
%phi_A=45;   %deg
%lambda_A=30; %deg
%h_h=350; %m

%latitudine del punto B
%phi_B=45 1'12''.8585;   %deg
%lambda_B=300'59''.3127 ; %deg
%h_A=350; %m
h_A=350; %m
h_B=1850.529; %m

%parametri ellissoide Hayford
a=6378388;%m
e_2=0.006722670022333;

%% CONVERSIONE MISURE ANGOLARI
%conversione delle misure angoli da gradi sessagesimali a radianti

phi_A=45/180*pi; %rad
lambda_A=30/180*pi; %rad
%conversione delle misure angoli da gradi sessagesimali a radianti

phi_B=(45+1/60+12.8585/3600)/180*pi; %rad
lambda_B=(30+0/60+59.3127/3600)/180*pi; %rad

%% CONVERSIONE DA COORDINATE GEOGRAFICHE A COORDINATE CARTESIANE GEOCENTRICHE
% calcolo dei raggi delle sezioni grannormali
N_A=a/(1-e_2*(sin(phi_A))^2)^0.5; %m
N_B=a/(1-e_2*(sin(phi_B))^2)^0.5; %m

% calcolo delle coordinate cartesiane geocentriche
% punto A
x_A=(N_A+h_A)*cos(phi_A)*cos(lambda_A);%m
y_A=(N_A+h_A)*cos(phi_A)*sin(lambda_A);%m
z_A=(N_A*(1-e_2)+h_A)*sin(phi_A); %m

% punto B
x_B=(N_B+h_B)*cos(phi_B)*cos(lambda_B); %m
y_B=(N_B+h_B)*cos(phi_B)*sin(lambda_B); %m
z_B=(N_B*(1-e_2)+h_B)*sin(phi_B); %m

%% CALCOLO DELLA DISTANZA NELLO SPAZIO
%distanza euclidea nello spazio
dist_AB=sqrt((x_A-x_B)^2+(y_A-y_B)^2+(z_A-z_B)^2); %m