% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

% ESERCIZIO 2.3: COMPENSAZIONE EMPIRICA DELLA POLIGONALE

%% DATI 

%coordinate dei vertici della poligonale (A e P) e dei vertici usati
%per l'orientamento (P e Q) [m]
xA=17292.50;
yA=4190.80;
xB=13885.70;
yB=9823.80;
xP=20460.40;
yP=5676.00;
xQ=19658.70;
yQ=11596.10;
 
%angoli osservati [gon]
% alphaA=137.1977;
% alpha1=151.5803;
% alpha2=238.2972;
% alpha3=187.5906;
% alpha4=145.0715;
% alphaP=166.3259;
alpha =[137.1977 151.5803 238.2972 187.5906 145.0715 166.3259]';
alpha=alpha*pi/200;
 
%lati osservati [m]
% lA1=773.978;
% l12=661.354;
% l23=714.156;
% l34=940.492;
% l4P=764.392;
l=[773.978 661.354 714.156 940.492 764.392]';
 
 
%% COMPENSAZIONE ANGOLARE
 
thetaBA=atan2((xA-xB),(yA-yB));
thetaPQ=atan2((xQ-xP),(yQ-yP));
 
 if (thetaBA<0)
    thetaBA=thetaBA+2*pi;
 end
 
 if (thetaPQ<0)
    thetaPQ=thetaPQ+2*pi;
 end
 
%propagazione azimut
theta=zeros(6,1);
theta(1)=thetaBA+alpha(1)+pi;
if theta(1)>2*pi
    theta(1)=theta(1)-2*pi;
end
for i=2:length(alpha)
    theta(i)=theta(i-1)+alpha(i)+pi;
    if theta(i)>2*pi
    theta(i)=theta(i)-2*pi;
    end
end
 
 
%% CONDIZIONE DI CONGRUENZA ANGOLARE
n=length(alpha)-2;
v_a=thetaBA+sum(alpha)-n*pi-thetaPQ;
eps_a=v_a/length(alpha);
 
%% CORREZIONE ANGOLARE 
alpha_corr=alpha-eps_a;
%alpha_corr_g=alpha_corr*200/pi;
theta_corr=zeros(size(theta,1),1);
theta_corr(1)=theta(1);
 for i=2:length(alpha_corr)
     theta_corr(i)=theta_corr(i-1)+alpha(i-1)+pi;
     if theta_corr(i)>2*pi
     theta_corr(i)=theta_corr(i)-2*pi;
     end
 end
  
%propagazione azimut
theta_corr=zeros(7,1);
theta_corr(1)=thetaBA;
for i=2:length(theta_corr)
    theta_corr(i)=theta_corr(i-1)+alpha_corr(i-1)+pi;
    if theta_corr(i)>2*pi
    theta_corr(i)=theta_corr(i)-2*pi;
    end
end
  
theta_corr_g=theta_corr*200/pi;
data=theta_corr;
 
%% COMPENSAZIONE DEI LATI
l_sin(:,1)=l(:,1).*sin(theta_corr(2:end-1,1));
l_cos(:,1)=l(:,1).*cos(theta_corr(2:end-1,1));
 
v_x=sum(l_sin)-(xP-xA);
v_y=sum(l_cos)-(yP-yA);
 
eps_x=v_x/sum(l);
eps_y=v_y/sum(l);
 
eps_x_c=l*eps_x;
eps_y_c=l*eps_y;
 
l_sin_corr=l_sin-eps_x_c;
l_cos_corr=l_cos-eps_y_c;
 
%% COORDINATE COMPENSATE
data=zeros(6,2);
data(1,1)=xA;
data(1,2)=yA;
 
for i=2:size(data,1)
    data(i,1)=data(i-1,1)+l_sin_corr(i-1);
    data(i,2)=data(i-1,2)+l_cos_corr(i-1);
end
