% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 3.1: INQUADRAMENTO DI UNA RETE DI DETTAGLIO SU PUNTI GPS

%% DATI 
clc, clear all, close all

% per il calcolo della soluzione linearizza si rimanda allo script 
% es_2_8.m e es_C2_2.m
 
% coordinate dei vertici nella rete topografica classica
v_topo=[6 53788.080 -8640.593;
        7 29788.829 -20674.040;
        8     0.000      0.000;
        9 14854.951  23167.776];

%coordinate dei punti GPS nel sistema di riferimento geocentrico
GPS={'GPS6' 4576119.770 1309960.893 4232444.394;
     'GPS8' 4584392.970 1256458.183 4238520.625};
%coordinate dei punti GPS nel sistema di riferimento locale
GPS_loc={'GPS6' 53786.627 -8638.695;
         'GPS8'     0.000     0.000};
%% CALCOLO DEI PARAMETRI DELLA TRASFORMAZIONE

    A=[ 1 0  v_topo(1,2) -v_topo(1,3);
        0 1 v_topo(1,3)  v_topo(1,2);
        1 0 v_topo(3,2) -v_topo(3,3);
        0 1 v_topo(3,3)  v_topo(3,2)];
    
     Y=[GPS_loc{1,2};
       GPS_loc{1,3};
        GPS_loc{2,2};
       GPS_loc{2,3}];
   
   %caclolo della soluzione x=inv(A)*Y. Si ricorda che in Matlab  pi
   %efficiente utilizzare la soluzione x=A\Y
   x=A\Y;
   
   %calcolo dell'angolo theta
   theta=atan(x(4)/x(3));
   
   %calcolo del parametro di scalal lambda
   lambda=sqrt(x(4)^2+x(3)^2);
   
   t=[x(1);x(2)];
     
      %% CALCOLO DELLE COORDINATE DEI VERTICI 

%matrice di rotazione
R=[cos(theta) -sin(theta);
   sin(theta)  cos(theta)];

% calcolo delle coordiante dei vertici 6-9 nella rete topografica classica,
% inquadrati nella rete GPS
 X=[6 (lambda*R*v_topo(1,2:3)'+t)';
    7 (lambda*R*v_topo(2,2:3)'+t)';
    8 (lambda*R*v_topo(3,2:3)'+t)'
    9 (lambda*R*v_topo(4,2:3)'+t)'];

     


  
  
