% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 4.1: UN ESEMPIO DI CALCOLO NEL PIANO DI GAUSS



%% DATI
% coordinate del punto P
NP=5008817.78; %m
EP=1402488.09; %m
%phi_p=4531'31''.919
phi_P=(45+13/60+30.919/3600)/180*pi; %rad
%lambdaQmm=-314'36''.479
lambdaPmm=(-4-41/60-39.744/3600)/180*pi; %rad

% coordinate del punto Q
NQ=4961136.86; %m
EQ=1516519.10; %m
%phi_p=4531'31''.919
phi_Q=(44+48/60+9.408/3600)/180*pi; %rad
%lambdaQmm=-314'36''.479
lambdaQmm=(-3-14/60-36.479/3600)/180*pi; %rad

%parametri dell'elissoide di Hayford
a= 6378388; %m
e_2=0.006722670022333;

%% CALCOLO DELLE COORDINATE DEPURATE DELLA FALSA ORIGINE
%Le coordinate sono in Gauss-Boaga, quindi la falsa origine Est
% pari a 1500000 m
%falsa origine
f_or=1500000;
Ep_d=EP-f_or; %m
Eq_d=EQ-f_or; %m

%% CALCOLO DEL RAGGIO R E DEI RAGGI PRINCIPALI DI CURVATURA
phi_m=(phi_P+phi_Q)/2;
R_2=(a/(1-e_2*(sin(phi_m))^2)^0.5)*((a*(1-e_2))/(1-e_2*(sin(phi_m))^2)^1.5); %m


%% CALCOLO DELL'AZIMUT TRA I PUNTI P E Q
%azimut thetaPQ
thetaPQ_c=atan((Eq_d-Ep_d)/(NQ-NP))+pi;

%% CALCOLO DELLA CONVERGENZA DEL MERIDIANO
% Si ricorda che le longitudini sono riferite a Roma Monte Mario, quindi 
% necessario sottrare la longitudine lambdaMM di Monte Mario
lambdaMM=(12.452333)/180*pi; %rad
% longitudine del fuso centrale
lambdaMC=9/180*pi;
lambda=lambdaPmm+lambdaMM-lambdaMC;
y=lambda*sin(phi_P)*(1+1/3*lambda^2*cos(1+(3*e_2)/(1-e_2)*(cos(phi_P))^2));

%% CALCOLO DELLA RIDUZIONE ALLA CORDA E DELL'AZIMUT CORRETTO
%calcolo della riduzione alla corda
e_PQ=((NP-NQ)*(2*Ep_d+Eq_d))/(0.9996^2*6*R_2);
% calcolo dell'azimut PQ corretto
thetaPQ=thetaPQ_c-abs(y)+abs(e_PQ);

%% CALCOLO DELLA DISTANZA ELLISSOIDICA PQ
% calcolo della distanza cartografica PQ
d_PQ_cart=sqrt((Eq_d-Ep_d)^2+(NQ-NP)^2);
%calcolo del modulo di deformazione lineare tra i punti P e Q
m=0.9996+(Ep_d^2+Ep_d*Eq_d+Eq_d^2)/(0.9996*6*R_2);
% calcolo della distanza ellissoidica
dPQ_ell=d_PQ_cart/m;