% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 4.3: USO DELLA CARTA DI GAUSS PER CALCOLI TOPOGRAFICI 
% INGEGNERISITICI
%% DATI
clc, clear all, close all
%raggio medio terrestre
R=6370000; %m
%PUNTO 1 - imbocco della galleria
N1=5084660.35; %m
E1=1478514.68; %m
h1=1230.12; %m
%PUNTO 2 - sbocco galleri
N2=5102127.48; %m
E2=1479621.30; %m
h2=1650.25; %m
%PILASTRINO DI ORIENTAMENTO
Np=5085550.22; %m
Ep=1477910.54; %m
k=0.15;

%% CALCOLO DELLE COORDINATE DEPURATE DELLA FALSA ORIGINE
%Le coordinate sono in Gauss-Boaga, quindi la falsa origine Est
% pari a 1500000 m
%falsa origine
f_or=1500000;
E1_d=E1-f_or; %m
E2_d=E2-f_or; %m
Ep_d=Ep-f_or; %m

%% CALCOLO DELLA LUNGHEZZA REALE DELLA GALLERIA
% calcolo del modulo di deformazione lineare m
m=0.9996+(E1_d^2+E2_d*E1_d+E2_d^2)/(0.9996*6*R^2);
%calcolo della lunghezza della galleria sulla carta
d12_cart=sqrt((E1_d-E2_d)^2+(N1-N2)^2);
d12_ell=d12_cart/m;
%calcolo dell'angolo al centro
delta=d12_ell/R;
%calcolo della lunghezza reale della galleria
d10=h1+R;
d20=h2+R;
D12=sqrt(d10^2+d20^2-2*d10*d20*cos(delta));

%% CALCOLO DELL'ANGOLO ZENITALE DELL'ASSE DELL'IMBOCCO
%calcolo dell'angolo zenitale teorico
z=asin((R+h2)*sin(delta)/D12);
%calcolo dell'angolo zenitale reale
z_r=z-k/(2*R)*d12_ell;

%% CALCOLO DELL'ANGOLO AZIMUTALE TRA IL RIFERIEMNTO E L'ASSE
%calcolo dell'angolo alpha_1
theta_12=atan((E2_d-E1_d)/(N2-N1));
theta_1P=atan((E1_d-Ep_d)/(N1-Np))+2*pi;
alpha_1=theta_12+(2*pi-theta_1P);
%calcolo della riduzione alla corda
e_1P=(N1-Np)*(2*E1_d+Ep_d)/(0.9996^2*6*R^2);
e_12=(N1-N2)*(2*E1_d+E2_d)/(0.9996^2*6*R^2);

%calcolo dell'angolo corretto alpha
alpha=alpha_1+abs(e_1P)-abs(e_12);

