% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 4.5: PROGETTAZIONE DI UNA FUNIVIA
%% DATI
clc, clear all, close all

% parametri ellissoidici
a=6378137; %m
e_2=0.00669438;
D_AC=2500;

%Coordinate del punto A
EA=526345.15; %m
NA=4985234.85; %m
hA=1248; %m
%latA =451'12.270''
latA=(45+1/60+12.270/3600)/180*pi; %rad
%longA =920'3.722''
longA=(9+20/60+3.722/3600)/180*pi; %rad

%Coordinate del punto B
EB=528634.35; %m
NB=4980001.55; %m
hB=2237; %m
%latB =4458'22.358''
latB=(44+58/60+22.358/3600)/180*pi; %rad
%longB =921'47.230''
longB=(9+21/60+47.230/3600)/180*pi; %rad

%% SVOLGIMENTO
% calcolo del raggio R
R=a*sqrt(1-e_2)/(1-e_2*(sin((latA+latB)/2))^2);
%calcolo delle coordinate depurate della falsa origine
f_or=500000;
EA_d=EA-f_or; %m
EB_d=EB-f_or; %m
%distanza dAB cartografica
dAB=sqrt((EA-EB)^2+(NA-NB)^2);
%calcolo del modulo di deformazione lineare
m=0.9996+(EA_d^2+EA_d*EB_d+EB_d^2)/(0.9996*6*R^2);
%calcolo della distanza dAB ellissoidica 
d_AB_ell=dAB/m;
%calcolo dell'angolo al centro
delta_AB=d_AB_ell/R;
%calcolo della distanza D_AB (nello spazio)
D_AB=sqrt((R+hA)^2+(R+hB)^2-2*(R+hA)*(R+hB)*cos(delta_AB));
%calcolo dell'angolo zenitale Z_A
Z_A=asin((R+hB)*sin(delta_AB)/D_AB);


%% CALCOLO DELLE COORDINATE DEL PUNTO INTERMEDIO C

%calcolo della quota ellissoidica hC
hC=sqrt((R+hA)^2+D_AC^2-2*D_AC*(R+hA)*cos(pi-Z_A))- R;
%calcolo dell'angolo al centro delta_AC
delta_AC=acos(((R+hA)^2+(R+hC)^2-D_AC^2)/(2*(R+hA)*(R+hC)));
%calcolo della distanza ellissoidica dAC_ell
dAC_ell=R*delta_AC;
%calcolo della distanza cartografica d_AC
dAC=m*dAC_ell;
% coordinate cartografiche del punto C
EC=EA+dAC*(EB-EA)/dAB;
NC=NA+dAC*(NB-NA)/dAB;