% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 4.6:  CALCOLO DELLA LUNGHEZZA DI UNA CURVA STRADALE
%% DATI
clc, clear all, close all
R= 541.96; %m
ET1=1544277.23; %m
NT1=5002333.44; %m
EC=1544614.53; %m
NC=5002800.65; %m
Rt=6378000; %m

%% SVOLGIMENTO
%calcolo delle coordinate depurate della falsa origine
f_or=1500000;
ET1_d=ET1-f_or; %m
EC_d=EC-f_or; %m

% calcolo della distanza sulla carta T1C
d_T1C=sqrt((EC-ET1)^2+(NC-NT1)^2);

% calcolo della corda T1T2
alpha_c=2*acos((R^2+R^2-d_T1C^2)/(2*R^2));
corda=2*R*sin(alpha_c/2);

%calcolo del modulo di deformazione lineare
m=0.9996*(1+(ET1_d^2)/(0.9996^2*2*Rt^2));

%calcolo delle distanze sul terreno
dT1C_ell=d_T1C/m;
Rell=R/m;

%calcolo dell'azimuth thetaT1C
thetaT1C=atan2((EC-ET1),(NC-NT1));

%calcolo dello sviluppo della curva e degli altri angoli notevoli della
%circonferenza
svil=Rell*alpha_c;
alpha_tg=(pi-alpha_c/2)/2;

%% CALCOLO DELLE COORDINATE DEI PUNTI O E T2
%coordinate del punto O
EO=ET1+R*sin(thetaT1C+alpha_tg);
NO=NT1+R*cos(thetaT1C+alpha_tg);

ET2=ET1+corda*sin(thetaT1C+alpha_tg-(pi/2-alpha_c/2));
NT2=NT1+corda*cos(thetaT1C+alpha_tg-(pi/2-alpha_c/2));


