% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 4.7: CALCOLO DEL VOLUME DI UNO SPIANAMENTO DI COMPENSO

%% DATI
clc, clear all, close all

%coordinate del punto A
EA=1547344.82; %m
NA=5100997.15; %m
QA=104; %m

%coordinate del punto B
EB=1548497.62; %m
NB=5101785.86; %m
QB=102; %m

Q1=115; %m
Q2=113; %m

dA1_ell=904.13; %m
dA2_ell=306.34; %m
dB1_ell=1449.62; %m
dB2_ell=1104.72; %m

R=6378000; %m
%% SVOLGIMENTO
%calcolo delle coordinate depurate della falsa origine
f_or=1500000;
EA_d=EA-f_or; %m
EB_d=EB-f_or; %m
Em_d=(EA_d+EB_d)/2; %m

%calcolo della distanza carotgradica dAB
dAB=sqrt((EA-EB)^2+(NA-NB)^2);
%calcolo del modulto di deformazione lineare
m=0.9996*(1+(Em_d^2)/(0.9996^2*2*R^2));

%calcolo delle distanze sulla carta
dA1=dA1_ell*m; %m
dA2=dA2_ell*m; %m
dB1=dB1_ell*m; %m
dB2=dB2_ell*m; %m

%calcolo dell'azimuth thetaAB e degli angoli interni
thetaAB=atan2((EB-EA),(NB-NA));

alpha1AB=acos((dA1^2-dB1^2+dAB^2)/(2*dA1*dAB));
alphaBA2=acos((dAB^2+dA2^2-dB2^2)/(2*dA2*dAB));

thetaA1=thetaAB-alpha1AB;
thetaA2=thetaAB+alphaBA2;

%calcolo delle coordiante dei vertici incogniti (1 e 2)
E1=EA+dA1_ell*sin(thetaA1); %m
N1=NA+dA1_ell*cos(thetaA1); %m

E2=EA+dA2_ell*sin(thetaA2); %m
N2=NA+dA2_ell*cos(thetaA2); %m

%% CALCOLO QUOTA DEL BARICENTRO
% calcolo della quota del baricentro dei due triangoli A1B e B12
Qt_A12=(QA+Q1+Q2)/3;
Qt_B12=(QB+Q1+Q2)/3;

%calcolo della distanza d12
d12=sqrt((E1-E2)^2+(N1-N2)^2);
d12_ell=d12/m;

%calcolo delle superficie dei triangoli A1B e B12
alpha1B2=acos((dB1_ell^2+dB2_ell^2-d12_ell^2)/(2*dB1_ell*dB2_ell));
At_A12=1/2*dA1_ell*dA2_ell*sin(thetaA2-thetaA1); %m^2
At_B12=1/2*dB1_ell*dB2_ell*sin(alpha1B2); %m^2

%calcolo dell'area totale dell'appezzamento come somma dell'area dei due
%triangoli
A_A12B=At_A12+At_B12; %m^2

%calcolo della quota del barcientro (media pesata sull'area)
Q_bar=(Qt_A12*At_A12+Qt_B12*At_B12)/A_A12B; %m

%% INDIVIDUAZIONI DEI PUNTI DI PASSAGGIO

%calcolo delle quote dei punti di passaggio
dQ1_bar=Q_bar-Q1;
dQ2_bar=Q_bar-Q2;
dQA_bar=Q_bar-QA;
dQB_bar=Q_bar-QB;

%calcolo delle posizioni dei punti di passaggio (interpolazione lienare)
dA_ppA1=dA1_ell*dQA_bar/(dQA_bar-dQ1_bar); %m
dA_ppA2=dA2_ell*dQA_bar/(dQA_bar-dQ2_bar); %m

dB_ppB1=dB1_ell*dQB_bar/(dQB_bar-dQ1_bar); %m
dB_ppB2=dB2_ell*dQB_bar/(dQB_bar-dQ2_bar); %m

%% CALCOLO DEL VOLUME DI ROPORTO (O STERRO)
% volume triangolo ppA1-A-ppA2
V_ppA1_A_ppA2=1/2*dA_ppA1*dA_ppA2*sin(thetaA2-thetaA1)*dQA_bar/3;
% volume triangolo ppB1-B-ppB2
V_ppB1_B_ppB2=1/2*dB_ppB1*dB_ppB2*sin(alpha1B2)*dQB_bar/3;
% calcolo del volume totale
Vtot=V_ppA1_A_ppA2+V_ppB1_B_ppB2;