% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.1: PROPAGAZIONE DELLA VARIANZA E CALCOLO DELLA PROBABILIT 

%% DATI
clc, clear all, close all
%W=3X-Y
mX=1;
mY=-2;
sigma2_X=1;
sigma2_Y=25;

%calcolo della media della funzione W
W1=-3;
W2=-2;
syms W X Y
W = 3*X-Y;
mW=double(subs(W,[X,Y],[mX,mY]));

c_a=3; %coefficiente di X
c_b=-1; %coefficiente di Y

%calcolo della varianza della funzione W
syms sigma_2W a b sigma_2_X sigma_2_Y
sigma_2W= a^2*sigma_2_X+b^2*sigma_2_Y;
sigma2W=double(subs(sigma_2W,[a,b,sigma_2_X,sigma_2_Y],[c_a,c_b,sigma2_X,sigma2_Y]));


Z1=standardizza(W1,mW,sigma2W);
Z2=standardizza(W2,mW,sigma2W);
P1=normcdf(Z1);
P2=normcdf(Z2);
P=P2-P1;
Prob=normcdf(W2,mW,sqrt(sigma2W))-normcdf(W1,mW,sqrt(sigma2W));

%% GRAFICI

%Creazione vettori con i dati necessari per creare il grafico
x = [-4:0.01:4];
norm = normpdf(x,0,1);
xz1=x(x<Z1);
normZ1=normpdf(xz1,0,1);
xz2=x(x<Z2);
normZ2=normpdf(xz2,0,1);

% figura Probabilit Z(W=-3)
figure;
axis([-4 4 0 0.45])
xvaluesz1 = [xz1'; xz1(end)'];
yvaluesz1 = [normZ1'; 0'];
fill(xvaluesz1,yvaluesz1,'r','FaceAlpha', 0.5);
hold on
plot(x,norm, 'LineWidth', 1);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit Z_W_=_-_3')

% figura Probabilit Z(W=-2)
figure;
xvaluesz2 = [xz2'; xz2(end)'];
yvaluesz2 = [normZ2'; 0'];
fill(xvaluesz2,yvaluesz2,'y', 'FaceAlpha', 0.5);
hold on
plot(x,norm, 'LineWidth', 1);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit Z_W_=_-_2')

p = normspec([Z1,Z2]);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit -3< Z <-2')


%% FUNZIONI 
function [ Z ] = standardizza( val, m, sigma2 )
%funzione che standardizza variabili
%richiede in input valore della variabile (val), media (m) e sigma (dev.st)
%in output da il valore della norm. standardizzata
Z=(val-m)/(sqrt(sigma2));
 end
