% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.10: PROPAGAZIONE DELLA VARIANZA: POLIGONALE APERTA ORIENTATA

%% DATI
clc, clear all, close all

P=[-800 800]; %m
sigma_P= 0.02; %m
S=[0 0];
alphaS=120/200*pi; %rad
alpha1=185/200*pi;  %rad
alpha2=230/200*pi;  %rad
d1=1000; %m
d2=1000; %m
d3=1000; %m
sigma_alpha=0.002/200*pi; %rad

n=3; %numero punti di cui si devono determinare le coordinate

% SVOLGIMENTO
%% CALCOLO DEGLI ANGOLI THETA E RELATIVE PRECISIONI

thetaSP=atan2((P(1,1)-S(1,1)),(P(1,2)-S(1,2)))+2*pi;
dSP=sqrt((P(1,1)-S(1,1))^2+(P(1,2)-S(1,2))^2);
alpha=[alpha1;alpha2];
% soluzione con formula iterativa
theta=thetaSP+alphaS-2*pi;
for i=2:n
    theta(i)=theta(i-1)-pi+alpha(i-1);
end

%preallozazione variabile sigma2 in memoria
sigma2=zeros(1,n);
sigma_2_SP=sigma_P^2/dSP^2;
%calcolo delle varianze con la formula iterativa
for i=1:n
    sigma2(i)=i*sigma_alpha^2+sigma_P^2/dSP^2;
end

%% CALCOLO DELLE COORDINATE DEI PUNTI DELLA POLIGONALE
d=[d1 d2 d3];

%calcolo coordinate del punto 1
coord(1,1)=S(1,1)+d(1,1)*sin(theta(1,1));
coord(1,2)=S(1,2)+d(1,1)*cos(theta(1,1));

%calcolo delle coordinate in modo iterativo
% dal punto 2 al punto n


for i=2:n
    coord(i,1)=coord(i-1,1)+d(i)*sin(theta(1,i));
    coord(i,2)=coord(i-1,2)+d(i)*cos(theta(1,i));
end

%% CALCOLO DELLE PRECISIONI DEI PUNTI
% applicazioni della legge di propagazione di varianza e covarianza

Cpp=cell(n,1);
J=cell(n,1);

%creazione vettori utili per il cacolo di J in modo iterativo
dcos=d.*cos(theta);
dsin=d.*sin(theta);
k=1:1:n;
idcos=k.*d.*cos(theta);
idsin=k.*d.*sin(theta);

%calcolo J in modo iterativo
for i=1:n
J{i}=[sum(dcos(1:i))  sum(idcos(1:i));
   sum(-dsin(1:i)) sum(-idsin(1:i))];
end

clear dcos dsin idcos idsin k
Ctheta=diag([sigma_2_SP sigma_alpha^2]);
for i=1:n
    Cpp{i}=J{i}*Ctheta*J{i}';
end