% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.3: PROPAGAZIONE DELLA VARIANZA E CALCOLO DELLA PROBABILIT 

%% DATI
clc, clear all, close all
%INTERVALLO [3,5]
%W  distribuita normalmente W[2,20]

W1=3;
W2=5;
mW=2;
sigma2W=20;

Z1=standardizza(W1,mW,sigma2W);
Z2=standardizza(W2,mW,sigma2W);
P1=normcdf(Z1);
P2=normcdf(Z2);
P=P2-P1;
Prob=normcdf(W2,mW,sqrt(sigma2W))-normcdf(W1,mW,sqrt(sigma2W));

%% GRAFICI

%Creazione vettori con i dati necessari per creare il grafico
x = [-4:0.01:4];
norm = normpdf(x,0,1);
xz1=x(x<Z1);
normZ1=normpdf(xz1,0,1);
xz2=x(x<Z2);
normZ2=normpdf(xz2,0,1);

% figura Probabilit Z(W=-?)
figure;
axis([-4 4 0 0.45])
xvaluesz1 = [xz1'; xz1(end)'];
yvaluesz1 = [normZ1'; 0'];
fill(xvaluesz1,yvaluesz1,'r','FaceAlpha', 0.5);
hold on
plot(x,norm, 'LineWidth', 1);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit Z_W_=_3')

% figura Probabilit Z(W=?)
figure;
xvaluesz2 = [xz2'; xz2(end)'];
yvaluesz2 = [normZ2'; 0'];
fill(xvaluesz2,yvaluesz2,'y', 'FaceAlpha', 0.5);
hold on
plot(x,norm, 'LineWidth', 1);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit Z_W_=_5')

p = normspec([Z1,Z2]);
ylabel('f_X(x)');
set(get(gca,'ylabel'),'rotation',0)
xlabel('x');
title('Probabilit 3< Z <5')


%% FUNZIONI 
function [ Z ] = standardizza( val, m, sigma2 )
%funzione che standardizza variabili
%richiede in input valore della variabile (val), media (m) e sigma (dev.st)
%in output da il valore della norm. standardizzata
Z=(val-m)/(sqrt(sigma2));
 end
