% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.6:PROPAGAZIONE DELLA VARIANZA PER DEFINIRE 
%LA CORRELAZIONE TRA LA MISURA DI UN LATO E LA SUPERFICIE DELLO STESSO 

%% DATI
clc, clear all, close all

sigma_a=0.005;
sigma_c=0.006;
sigma_beta=0.0005/200*pi;
a_n=1000;
c_n=1500;
beta_n=50/200*pi;

%% CALCOLI PRELIMINARI

%calcolo lato b
b_n=sqrt(a_n^2+c_n^2-2*a_n*c_n*cos(beta_n));

%S=0.5*a*c*sin(beta);
%caclolo derivate

%% DEFINIZIONE VARIABILI SIMBOLICHE

%derivate simboliche
syms a c beta
S=0.5*a*c*sin(beta);
dS=@(a, c, beta) S;
b=sqrt(a^2+c^2-2*a*c*cos(beta));
db=@(a, c, beta) b;

%% CALCOLO DELLE DERIVATE
dS_a=diff(dS,a);
dS_c=diff(dS,c);
dS_beta=diff(dS,beta);
dbb_a=diff(db,a);
dbb_c=diff(db,c);
dbb_beta=diff(db,beta);

%derivate calcolate in f0
vdS_a= vpa(subs(dS_a,[a, c, beta],[a_n, c_n, beta_n]));
vdS_c= vpa(subs(dS_c,[a, c, beta],[a_n, c_n, beta_n]));
vdS_beta= vpa(subs(dS_beta,[a, c, beta],[a_n, c_n, beta_n]));
vdb_a= vpa(subs(dbb_a,[a, c, beta],[a_n, c_n, beta_n]));
vdb_c= vpa(subs(dbb_c,[a, c, beta],[a_n, c_n, beta_n]));
vdb_beta= vpa(subs(dbb_beta,[a, c, beta],[a_n, c_n, beta_n]));

%% PROPAGAZIONE DI VARIANZA E COVARIANZA

Js=[double(vdS_a), double(vdS_c),double(vdS_beta);
    double(vdb_a), double(vdb_c),double(vdb_beta)];
Cacbeta=eye(3);
Cacbeta(1,1)=sigma_a^2*Cacbeta(1,1);
Cacbeta(2,2)=sigma_c^2*Cacbeta(2,2);
Cacbeta(3,3)=sigma_beta^2*Cacbeta(3,3);

%precsioni
sigma2bS=Js*Cacbeta*Js';
sigmaS=sqrt(sigma2bS(1,1));
sigmab=sqrt(sigma2bS(2,2));

%coefficiente di correlazione
rBS=sigma2bS(1,2)/(sigmaS*sigmab);

