% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.7: PROPAGAZIONE DELLA VARIANZA APPLICATA A UNA FIGURA TRIANGOLARE 
%PER IL CALCOLO DELLAREA E DELLA SUA PRECISIONE 

%% DATI
clc, clear all, close all

L_n= [30, 110, 250]/200*pi; %rad
d_n= [500, 1000, 500]; %m
sigmaL=0.001/200*pi; %rad;
sigmaD_n=(5+2.*d_n/1000)./1000; %[m]
 
%SOLUZIONE
%angoli interni
alpha_n=[L_n(2)-L_n(1),L_n(3)-L_n(2),2*pi-(L_n(3)-L_n(1))];
%area tot S=s1+s2+s3
S_n=1/2*d_n(1)*d_n(2)*sin(alpha_n(1))+1/2*d_n(2)*d_n(3)*sin(alpha_n(2))+1/2*d_n(1)*d_n(3)*sin(alpha_n(3));
 
%calcolo varianza C_a1a2a3
%derivate simboliche
syms L1 L2 L3
alpha= [L2-L1 , L3-L2, 2*pi-(L3-L1)];
dalpha=@(L1,L2,L3) alpha;
dalpha_L1=diff(dalpha,L1);
dalpha_L2=diff(dalpha,L2);
dalpha_L3=diff(dalpha,L3);
J_L1L2L3=[double(dalpha_L1'),double(dalpha_L2'),double(dalpha_L3')];
 
C_LL=sigmaL^2*eye(3);
 
C_a1a2a3=J_L1L2L3*C_LL*J_L1L2L3';
 
%calcolo varianza C_S
%derivate simboliche
syms alpha1 alpha2 alpha3 d1 d2 d3
S=1/2*d1*d2*sin(alpha1)+1/2*d2*d3*sin(alpha2)+1/2*d1*d3*sin(alpha3);
dS=@(alpha1,alpha2,alpha3,d1,d2,d3) S;
dS_alpha1=diff(dS,alpha1);
dS_alpha2=diff(dS,alpha2);
dS_alpha3=diff(dS,alpha3);
dS_d1=diff(dS,d1);
dS_d2=diff(dS,d2);
dS_d3=diff(dS,d3);
 
%derivate calcolate in f0
vdS_alpha1= vpa(subs(dS_alpha1,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
vdS_alpha2= vpa(subs(dS_alpha2,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
vdS_alpha3= vpa(subs(dS_alpha3,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
vdS_d1= vpa(subs(dS_d1,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
vdS_d2= vpa(subs(dS_d2,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
vdS_d3= vpa(subs(dS_d3,[alpha1,alpha2,alpha3,d1,d2,d3],[alpha_n(1),alpha_n(2), alpha_n(3), d_n(1), d_n(2),d_n(3)]));
 
J_S=[double(vdS_alpha1),double(vdS_alpha2),double(vdS_alpha3),double(vdS_d1),double(vdS_d2),double(vdS_d3)];
 
%Matrice Cxx
Cdd=diag(sigmaD_n.^2);
Cxx=[C_a1a2a3, zeros(3);
    zeros(3), Cdd];
sigma2S=J_S*Cxx*J_S';
sigmaS=sqrt(sigma2S);