% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.8: PROPAGAZIONE DELLA VARIANZA: DETERMINAZIONE DELLE COORDINATE DI UN PUNTO E 
%DELLA PRECISIONE DI STIMA AL VARIARE DELLE GRANDEZZE 
%UTILIZZATE NELLA SUA DETERMINAZIONE (ANGOLI O DISTANZE)

%% DATI
clc, clear all, close all

%alpha_1=45 gon;
alpha_1=45/200*pi; %rad
%alpha_2=75 gon;
alpha_2=75/200*pi; %rad
%sigma_alpha_1=sigma_alpha_2=20cc;
sigma_alpha_1=0.0020/200*pi; %rad
sigma_alpha_2=0.0020/200*pi; %rad
d_12=1000; %m
d_13=971.42; %m
sigma_d_13= 0.01; %m
d_23=682.87; %m
sigma_d_23=0.01; %m
rho_d12_d_23=0.5; 


%% SOLUZIONE UTILIZZANDO SOLO MISURE DI DISTANZA
% calcoolo della coordinata x3 con sole misure di distanza
x3_d=(d_12^2+d_13^2-d_23^2)/(2*d_12);

%definizione delle variabili simboliche
syms x3d d12 d13 d23
x3d=(d12^2+d13^2-d23^2)/(2*d12);

%calcolo delle derivate parziali
dx3d =@(d12,d13,d23) x3d;
x3d_d13=diff(dx3d,d13);
x3d_d23=diff(dx3d,d23);

%sostituzione dei valori numerici nelle derivate
x3d_d13_n=double(subs(x3d_d13,[d12,d13,d23],[d_12,d_13,d_23]));
x3d_d23_n=double(subs(x3d_d23,[d12,d13,d23],[d_12,d_13,d_23]));

%propagazione di varianza e covarianza
sigma_x3_d=sqrt(x3d_d13_n^2*sigma_d_13^2+x3d_d23_n^2*sigma_d_23^2+2*x3d_d13_n*x3d_d23_n*sigma_d_13*sigma_d_23*rho_d12_d_23);

%% SOLUZIONE UTILIZZANDO SOLO MISURE ANGOLARI

% calcoolo della coordinata x3 con sole misure angolari
x3_a=(d_12*sin(alpha_2)*cos(alpha_1))/sin(alpha_1+alpha_2);

%definizione delle variabili simboliche
syms x3a alpha1 alpha2 d12
x3a=(d12*sin(alpha2)*cos(alpha1))/sin(alpha1+alpha2);

%calcolo delle derivate parziali
dx3a =@(d12,alpha1,alpha2) x3a;
x3a_alpha1=diff(dx3a,alpha1);
x3a_alpha2=diff(dx3a,alpha2);

%sostituzione dei valori numerici nelle derivate
x3d_alpha1_n=double(subs(x3a_alpha1,[d12,alpha1,alpha2],[d_12,alpha_1,alpha_2]));
x3d_alpha2_n=double(subs(x3a_alpha2,[d12,alpha1,alpha2],[d_12,alpha_1,alpha_2]));

%propagazione di varianza e covarianza

sigma_x3_a=sqrt(x3d_alpha1_n^2*sigma_alpha_1^2+x3d_alpha2_n^2*sigma_alpha_2^2);

