% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 5.9: PROPAGAZIONE DELLA VARIANZA: DETERMINAZIONE DI DISTANZE E 
% DELLE RELATIVE PRECISIONI

%% DATI
clc, clear all, close all
x_1=0; %ascissa punto 1 [m]
p2=[800 0]; %coordinate punto 2 [m]
p3=[690 1100]; %coordinate punto 3 [m]
C33=[25 -20;
     -20 64]; %matrice var-cov C33 [mm^2]
d_12 = 1120; %m
sigma_d_12=0.01; %m

%% SVOLGIMENTO
%conversione matrice C33 in m2
C33=C33*10^-6;
%% calcolo delle coordinata y del punto 1 e relativa precisione
% calcolo delle coordinata y del punto 1
y_1=sqrt(d_12^2-p2(1,1)^2);

%definizione delle variabili simboliche
syms y1 d12 x2
y1=sqrt(d12^2-x2^2);

%calcolo delle derivate parziali
dy1 =@(d12, x2) y1;

dy1_d12=diff(dy1,d12);

%sostituzione dei valori numerici nelle derivate
x3d_d12_n=double(subs(dy1_d12,[d12, x2],[d_12,p2(1,1)]));

%appllcazione legge di propagazione di varianza e covarianza
sigma_y1=sqrt(x3d_d12_n^2*sigma_d_12^2);

%% calcolo della distanza d13 e relativa precisione
% calcolo della distanza d1
d_13=sqrt((x_1-p3(1,1))^2 +(y_1-p3(1,2))^2);

%definizione delle variabili simboliche
syms d13 x1 x3 y1 y3
d13=sqrt((x1-x3)^2 +(y1-y3)^2);

%calcolo delle derivate parziali
dd13 =@(x1, x3, y1,y3) d13;

dd13_x3=diff(dd13,x3);
dd13_y3=diff(dd13,y3);
dd13_y1=diff(dd13,y1);


%sostituzione dei valori numerici nelle derivate
dd13_x3_n=double(subs(dd13_x3,[x1,y1,x3,y3],[x_1,y_1,p3(1,1),p3(1,2)]));
dd13_y3_n=double(subs(dd13_y3,[x1,y1,x3,y3],[x_1,y_1,p3(1,1),p3(1,2)]));
dd13_y1_n=double(subs(dd13_y1,[x1,y1,x3,y3],[x_1,y_1,p3(1,1),p3(1,2)]));

%appllcazione legge di propagazione di varianza e covarianza
%definizione della matrice C_x3y3y1
C_x3y3y1=blkdiag(C33,sigma_y1^2);
%definizione della matrice Jd13
J_d13=[dd13_x3_n dd13_y3_n dd13_y1_n];
      
sigma_d13=sqrt(J_d13*C_x3y3y1*J_d13');
      
%% calcolo della distanza d23 e relativa precisione
% calcolo della distanza d1
d_23=sqrt((p2(1,1)-p3(1,1))^2 +(p2(1,2)-p3(1,2))^2);

%definizione delle variabili simboliche
syms d23 x2 y2
d23=sqrt((x2-x3)^2 +(y2-y3)^2);

%calcolo delle derivate parziali
dd23 =@(x2, x3, y2,y3) d23;

dd23_x3=diff(dd23,x3);
dd23_y3=diff(dd23,y3);
dd23_y1=diff(dd23,y1);

%sostituzione dei valori numerici nelle derivate
dd23_x3_n=double(subs(dd23_x3,[x2,y2,x3,y3],[p2(1,1),p2(1,2),p3(1,1),p3(1,2)]));
dd23_y3_n=double(subs(dd23_y3,[x2,y2,x3,y3],[p2(1,1),p2(1,2),p3(1,1),p3(1,2)]));
dd23_y1_n=double(subs(dd23_y1,[x2,y2,x3,y3],[p2(1,1),p2(1,2),p3(1,1),p3(1,2)]));

%appllcazione legge di propagazione di varianza e covarianza
%definizione della matrice Jd13
J_d23=[dd23_x3_n dd23_y3_n dd23_y1_n];
      
sigma_d23=sqrt(J_d23*C_x3y3y1*J_d23');
