% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESEMPIO 6.7:
% STIMA DEL RAGGIO DELLA CIRCONFERENZA

%% DATI
clc, clear all, close all

xx=[2.11 2.20 -1.94 -2.09 1.01]'; %m
yy=[3.50 -3.44 3.45 -3.47 3.90]'; %m

r_app=3.8; %m valore approssimato del raggio

%% SVOLGIMENTO
% equazione di condizione
%F(alpha, x)=x^2 +y^2 -r^2 =0;
%utilizzo del calcolo simbolico 
%per calcolare le derivate
syms x y r
F=x^2 +y^2 -r^2;
dF=@(x, y, r) F;

d_x=diff(dF,x);
d_y=diff(dF,y);
d_r=diff(dF,r);

%sostituzione dei valori osservati alle espressioni simboliche
%precedentemente calcolate

B=zeros(5,10);
B(1,1)=-vpa(subs(d_x,[x,y],[xx(1,1),yy(1,1)]));
B(1,2)=-vpa(subs(d_y,[x,y],[xx(1,1),yy(1,1)]));
B(2,3)=-vpa(subs(d_x,[x,y],[xx(2,1),yy(2,1)]));
B(2,4)=-vpa(subs(d_y,[x,y],[xx(2,1),yy(2,1)]));
B(3,5)=-vpa(subs(d_x,[x,y],[xx(3,1),yy(3,1)]));
B(3,6)=-vpa(subs(d_y,[x,y],[xx(3,1),yy(3,1)]));
B(4,7)=-vpa(subs(d_x,[x,y],[xx(4,1),yy(4,1)]));
B(4,8)=-vpa(subs(d_y,[x,y],[xx(4,1),yy(4,1)]));
B(5,9)=-vpa(subs(d_x,[x,y],[xx(5,1),yy(5,1)]));
B(5,10)=-vpa(subs(d_y,[x,y],[xx(5,1),yy(5,1)]));

K=B*B';

A=-vpa(subs(d_r,r,r_app))*ones(5,1);
L=[xx(1,1)^2+yy(1,1)^2-r_app^2;
   xx(2,1)^2+yy(2,1)^2-r_app^2;
   xx(3,1)^2+yy(3,1)^2-r_app^2;
   xx(4,1)^2+yy(4,1)^2-r_app^2;
   xx(5,1)^2+yy(5,1)^2-r_app^2];

%% CALCOLO DELLA SOLUZIONE 
% stima della correzione delta_r da applicare al valore approssimato del
% raggio

delta_r=double(inv(A'*inv(K)*A)*A'*inv(K)*(L));

% calcolo del valore del raggio
r=r_app+delta_r;

