% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESEMPIO 6.8:
% STIMA AI MINIMI QUADRATI DI UN MODELLO POLINOMIALE
% y=a0+a1*t+a2*t^2
%% DATI
clc, clear all, close all

tt=[2 3 6 7 9 10]';
yy=[10.1 12.2 19.9 22.7 27.4 30.5]';

%% POPOLAMENTO MATRICI
%matrice disegno
A=[ones(size(tt,1),1), tt, tt.^2];
%vettore delle osservazioni
alpha0=yy;
L=zeros(size(tt,1),1);
delta=alpha0-L;
%calcolo della soluzione
x=inv(A'*A)*A'*delta;
%vettore degli scarti
u=alpha0-A*x;
%calcolo di sigma0_2_post
sigma0_2_post=u'*u/(size(yy,1)-size(x,1));

% calcolo Cxx
Cxx=sigma0_2_post*inv(A'*A);
% calcolo delle precisioni di stima dei parametri
sigma_a=sqrt(Cxx(1,1));
sigma_b=sqrt(Cxx(2,2));

%% TEST T-STUDENT
% si vuole testare l'ipotesi H0 per cui a2 sia significativamente nullo
t0_3=(x(3)-0)/sqrt(Cxx(3,3));
t_st = tinv(0.975,3);
% poiche |t0_3|<t_st l'ipotesi  accettata e a2  significativamente nullo

disp('test T-student')
if t0_3<t_st
 disp('ipotesi H0 accettata')
else
 disp('ipotesi H0 rifiutata')
end

%% SOLUZIONE DEL NUOVO MODELLO
% y=a0_a1*t
A_2=[ones(6,1) tt];
x_2=inv(A_2'*A_2)*A_2'*delta;
u_2=alpha0-A_2*x_2;

%calcolo di sigma0_2_post
sigma0_2_post_2=u_2'*u_2/(size(yy,1)-size(x_2,1));

%% TEST FISHER

F_0=sigma0_2_post/sigma0_2_post_2;
F= finv(0.95,3,2);

disp('test F-Fisher')
if F_0<F
 disp('ipotesi H0 accettata')
else
 disp('ipotesi H0 rifiutata')
end