% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 6.2: STIMA DEL PARAMETRO k DI UN MODELLO GEOLOGICO
%% DATI
%MODELLO FUNZIONALE
% z=100+k*G+0.0005*G^2;

clc, clear all, close all

z=[100.41 106.39 121.01 140.90 161.97]'; %mm
G=[25 110 202 283 349]';
sigmaZ=[0.020 0.030 0.020 0.020 0.030]'; %mm

%% POPOLAMENTO MATRICI MQ
%matrice disegno A
A=G;
%vettore delle osservazioni alpha_0
alpha0=z;
%vettore dei termini noti L
L=100+0.0005.*G.^2;
%matrice dei pesi P
sigma02Priori=0.020^2;
P=diag(sigma02Priori./sigmaZ.^2);


%% SOLUZIONE MINIMI QUADRATI
%matrice normale N
N=A'*P*A;
%termine noto normale Tn
Tn=A'*P*(alpha0-L);
% calcolo della soluzione
x=N\Tn;
%vettore delle osservazioni teoriche
alpha=A*x-L;
%vettore degli scarti
u=alpha0-A*x-L;
%sigma0^2 post
sigma_02_post=(u'*P*u)/(size(A,1)-size(A,2));
%matrice di varianza e covarianza delle incognite
Cxx=sigma_02_post*inv(N);
sigma_k=sqrt(Cxx(1,1));
%matrice di varianza e covariazna delle osservazioni C_alpha_alpha
C_alpha_alpha=sigma_02_post*A*inv(N)*A';
%matrice varianza e covarianza degli scarti
C_uu=sigma_02_post*inv(P)-C_alpha_alpha;

%% TEST STATISTICI
% TEST CHI QUADRO 
val=sigma_02_post/sigma02Priori*(size(A,1)-size(A,2));
chi2 = [chi2inv(0.025,(size(A,1)-size(A,2))),chi2inv(0.975,(size(A,1)-size(A,2)))];
if val>chi2(1)&& val<chi2(2)
   fprintf('MQ: Test Globale superato\n'); 
else
   fprintf('MQ: Test Globale NON superato\n'); 
end


% TEST RESIDUI STANDARDIZZATI 

%test residui =[residuo standardizzato,flag]
%flag=1 --> test non superato
%flag=0 --> test superato

test_residui=u./sqrt(diag(C_uu));

norm_dist = norminv([0.025 0.975],0,1);

ind= test_residui(:,1)<min(norm_dist)|test_residui(:,1)>max(norm_dist);
test_residui(ind,2)=1;
clear ind i

if any(test_residui(:,2))
   fprintf('MQ: Test dei resuidui standardizzati NON superato\n');
else
    fprintf('MQ: Test dei resuidui standardizzati superato\n');

end
