% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 6.3: CONFRONTO TRA MINIMI QUADRATI LINEARI E NON LINEARI NEL CASO DI 
%UN PROBLEMA DI ROTAZIONE PIANA


%% DATI
clc, clear all, close all

data={' ' 'sdr(uv)' 'sdr(uv)' 'sdr(xy)' 'sdr(xy)';
     'punto' 'u' 'v' 'X' 'Y';
     'P' 12 2 9.907 -7.054;
     'Q' 1 3 2.840 1.429;
     'S' 23 0 16.267 -16.246};
 
 %% SOLUZIONE MQ LINEARI
 % modello funzionale
 %X=m*( u+cos(alpha)+ v*sin(alpha))
 %Y=m*(-u*sin(alpha)+ v*cos(alpha))
 %a=m*cos(alpha);
 %b=m*sin(alpha);
  %x=[a b]'
 
 %matrice disegno A
 A_lin=[data{3,2}  data{3,3};
    data{3,3} -data{3,2};
    data{4,2}  data{4,3};
    data{4,3} -data{4,2};
    data{5,2}  data{5,3};
    data{5,3} -data{5,2}];

%vettore delle osservazioni alpha0
alpha0_lin=[data{3,4} data{3,5} data{4,4} data{4,5} data{5,4} data{5,5}]';

%vettore dei termini noti L
L_lin=zeros(size(A_lin,1),1);

P=eye(6);
%matrice normale N
N_lin=A_lin'*P*A_lin;
%termine noto normale Tn
Tn_lin=A_lin'*P*(alpha0_lin-L_lin);
% calcolo della soluzione
x_lin=N_lin\Tn_lin;

m_lin=sqrt(x_lin(1,1)^2+x_lin(2,1)^2);
alpha_lin=atan(x_lin(2,1)/x_lin(1,1));


%% SOLUZIONE MINIMI QUADRATI NON LINEARI
 % modello funzionale
 %X=m*( u+cos(alpha)+ v*sin(alpha))
 %Y=m*(-u*sin(alpha)+ v*cos(alpha))
 %x=delta_alpha
 %alpha=alpha+delta_alpha
 
 alpha_app=45/180*pi;
 
 %matrice disegno A
 A_nonLin=[-data{3,2}*sin(alpha_app)+data{3,3}*cos(alpha_app);
           -data{3,2}*cos(alpha_app)-data{3,3}*sin(alpha_app);
           -data{4,2}*sin(alpha_app)+data{4,3}*cos(alpha_app);
           -data{4,2}*cos(alpha_app)-data{4,3}*sin(alpha_app);
           -data{5,2}*sin(alpha_app)+data{5,3}*cos(alpha_app);
           -data{5,2}*cos(alpha_app)-data{5,3}*sin(alpha_app)];
 
 %vettore delle osservazioni alpha0
 alpha0_nonLin=[data{3,4} data{3,5} data{4,4} data{4,5} data{5,4} data{5,5}]';
 
 %vettore dei termini noti L
L_nonLin=[ data{3,2}*cos(alpha_app)+data{3,3}*sin(alpha_app);
          -data{3,2}*sin(alpha_app)+data{3,3}*cos(alpha_app);
           data{4,2}*cos(alpha_app)+data{4,3}*sin(alpha_app);
          -data{4,2}*sin(alpha_app)+data{4,3}*cos(alpha_app);
           data{5,2}*cos(alpha_app)+data{5,3}*sin(alpha_app);
          -data{5,2}*sin(alpha_app)+data{5,3}*cos(alpha_app)];
      
      
P=eye(6);
%matrice normale N
N_nonLin=A_nonLin'*P*A_nonLin;
%termine noto normale Tn
Tn_nonLin=A_nonLin'*P*(alpha0_nonLin-L_nonLin);
% calcolo della soluzione
x_nonLin=N_nonLin\Tn_nonLin;

alpha_nonLin=alpha_app+x_nonLin;


