% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 6.5: COMPENSAZIONE DI UNA RETE TOPOGRAFICA PLANIMETRICA
%% DATI
clc, clear all, close all

%punti =[nome punto, x[m], y[m]]
punti= [ 1 0 111.54;
         2 0     0;
         3 141.5 0];
%coordinate approssimmate del punto P
puntoP=[70.5 70.5];
d_P2=100; %m;
d_P3=100; %m;
alpha_P=75/180*pi; %rad

sigma_alpha=0.01/180*pi; %rad
%sigma_d=10[mm]+2[mm]*d[km]
sigma_d_P2=(10+2*0.1)/1000; %m
sigma_d_P3=(10+2*0.1)/1000; %m

%% CALCOLO DELLE COORDINATE APPROSSIMATE
dP1_app=sqrt((punti(1,2)-puntoP(1,1))^2+(punti(1,3)-puntoP(1,2))^2);
dP2_app=sqrt((punti(2,2)-puntoP(1,1))^2+(punti(2,3)-puntoP(1,2))^2);
dP3_app=sqrt((punti(3,2)-puntoP(1,1))^2+(punti(3,3)-puntoP(1,2))^2);
alphaP_app=atan((punti(1,2)-puntoP(1,1))/(punti(1,3)-puntoP(1,2)))-atan((punti(2,2)-puntoP(1,1))/(punti(2,3)-puntoP(1,2)))+pi;

%% LINEARIZZAZIONE DELLE EQUAZIONI

syms x1 y1 x2 y2 x3 y3 xP yP
  
dP2=sqrt((x2-xP)^2+(y2-yP)^2);
dP3=sqrt((x3-xP)^2+(y3-yP)^2);
alphaP=atan((x1-xP)/(y1-yP))-atan((x2-xP)/(y2-yP));

dP2_xP=diff(dP2,xP);
dP2_yP=diff(dP2,yP);
dP3_xP=diff(dP3,xP);
dP3_yP=diff(dP3,yP);
dalphaP_xP=diff(alphaP,xP);
dalphaP_yP=diff(alphaP,yP);


dP2_xP_n= double(subs(dP2_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP2_yP_n= double(subs(dP2_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP3_xP_n= double(subs(dP3_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP3_yP_n= double(subs(dP3_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dalphaP_xP_n= double(subs(dalphaP_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dalphaP_yP_n= double(subs(dalphaP_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));

%% POPOLAMENNTO MATRICI MQ 1a ITERAZIONE
%matrice disegno
A=[dP2_xP_n dP2_yP_n;
   dP3_xP_n dP3_yP_n;
   dalphaP_xP_n dalphaP_yP_n];

%vettore delle osservazioni
alpha_0=[d_P2 d_P3 alpha_P]';

%vettore dei termini noti
L=[dP2_app dP3_app alphaP_app]';

sigma_dz=0.0102; %m
sigma02Priori=sigma_dz^2;

%matrice dei pesi
P=diag(sigma02Priori./[sigma_d_P2^2 sigma_d_P3^2 sigma_alpha^2]);


%% SOLUZIONE MQ 1a ITERAZIONE
%matrice normale N
N=A'*P*A;
%termine noto Tn
Tn=A'*P*(alpha_0-L);
% vettore delle incognite x
x=N\Tn;
% x=N\Tn  un metodo pi efficace e stabile in matlab per calcolare
% x=inv(N)*Tn. E' utile sopratutto nel caso di grosse matrici
%vettore delle osservazioni teoriche

%aggiornamento cooordinate approssimate punto P
puntoP=puntoP+x';

%vettore degli scarti u
u=alpha_0-A*x-L;
%sigma0^2 posteriori
sigma_02_post=(u'*P*u)/(size(A,1)-size(A,2));
%matrice di varianza e covarianza delle incognite Cxx
Cxx=sigma_02_post*inv(N);
sigma_xP=sqrt(Cxx(1,1)); %m
sigma_yP=sqrt(Cxx(2,2)); %m
%matrice di varianza e covarianza delle osservazioni C_alpha_alpha
C_alpha_alpha=sigma_02_post*A*inv(N)*A';
%matrice varianza e covarianza degli scarti
C_uu=sigma_02_post*inv(P)-C_alpha_alpha;

%% TEST STATISTICI

% TEST CHI QUADRO
val=sigma_02_post/sigma02Priori*(size(A,1)-size(A,2));
chi2 = [chi2inv(0.025,(size(A,1)-size(A,2))),chi2inv(0.975,(size(A,1)-size(A,2)))];
if val>chi2(1)&& val<chi2(2)
   fprintf('Compensazione: Test Globale superato\n'); 
else
   fprintf('Compensazione: Test Globale NON superato\n'); 
end


%% SOLUZIONE MQ 2a ITERAZIONE

%calcolo dei nuovi valori delle distanze e dell'angolo approssimato
dP1_app2=sqrt((punti(1,2)-puntoP(1,1))^2+(punti(1,3)-puntoP(1,2))^2);
dP2_app2=sqrt((punti(2,2)-puntoP(1,1))^2+(punti(2,3)-puntoP(1,2))^2);
dP3_app2=sqrt((punti(3,2)-puntoP(1,1))^2+(punti(3,3)-puntoP(1,2))^2);
alphaP_app2=atan((punti(1,2)-puntoP(1,1))/(punti(1,3)-puntoP(1,2)))-atan((punti(2,2)-puntoP(1,1))/(punti(2,3)-puntoP(1,2)))+pi;



%% LINEARIZZAZIONE DELLE EQUAZIONI 2a ITERAZIONE
%sostituzione dei nuovi valori approssimati alle varaibili simboliche

dP2_xP_n2= double(subs(dP2_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP2_yP_n2= double(subs(dP2_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP3_xP_n2= double(subs(dP3_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dP3_yP_n2= double(subs(dP3_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dalphaP_xP2_n= double(subs(dalphaP_xP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));
dalphaP_yP2_n= double(subs(dalphaP_yP,[x1, y1, x2, y2, x3, y3, xP, yP],[punti(1,2),punti(1,3),punti(2,2),punti(2,3),punti(3,2),punti(3,3),puntoP(1,1),puntoP(1,2)]));

%% POPOLAMENNTO MATRICI MQ 2a ITERAZIONE
%matrice disegno
AA=[dP2_xP_n2 dP2_yP_n2;
   dP3_xP_n2 dP3_yP_n2;
   dalphaP_xP2_n dalphaP_yP2_n];

%vettore delle osservazioni
alpha_0=[d_P2 d_P3 alpha_P]';

%vettore dei termini noti
LL=[dP2_app2 dP3_app2 alphaP_app2]';

%% SOLUZIONE MQ 1a ITERAZIONE
%matrice normale N
N2=AA'*P*AA;
%termine noto Tn
Tn2=AA'*P*(alpha_0-LL);
% vettore delle incognite x
x2=N2\Tn2;
% x=N\Tn  un metodo pi efficace e stabile in matlab per calcolare
% x=inv(N)*Tn. E' utile sopratutto nel caso di grosse matrici
%vettore delle osservazioni teoriche

%aggiornamento cooordinate approssimate punto P
puntoP=puntoP+x2';

%vettore degli scarti u
u2=alpha_0-AA*x2-LL;
%sigma0^2 posteriori
sigma_02_post2=(u2'*P*u2)/(size(A,1)-size(A,2));
%matrice di varianza e covarianza delle incognite Cxx
Cxx2=sigma_02_post2*inv(N2);
sigma_xP2=sqrt(Cxx2(1,1)); %m
sigma_yP2=sqrt(Cxx2(2,2)); %m
%matrice di varianza e covarianza delle osservazioni C_alpha_alpha
C_alpha_alpha2=sigma_02_post2*AA*inv(N2)*AA';
%matrice varianza e covarianza degli scarti
C_uu2=sigma_02_post2*inv(P)-C_alpha_alpha2;

%% TEST STATISTICI

% TEST CHI QUADRO 
val=sigma_02_post/sigma02Priori*(size(A,1)-size(A,2));
chi2 = [chi2inv(0.025,(size(A,1)-size(A,2))),chi2inv(0.975,(size(A,1)-size(A,2)))];
if val>chi2(1)&& val<chi2(2)
   fprintf('Compensazione: Test Globale superato\n'); 
else
   fprintf('Compensazione: Test Globale NON superato\n'); 
end


% TEST RESIDUI STANDARDIZZATI 

%test residui =[residuo standardizzato,flag]
%flag=1 --> test non superato
%flag=0 --> test superato

test_residui=u2./sqrt(diag(C_uu2));

norm_dist = norminv([0.025 0.975],0,1);

ind= test_residui(:,1)<min(norm_dist)|test_residui(:,1)>max(norm_dist);
test_residui(ind,2)=1;
clear ind i

if any(test_residui(:,2))
   fprintf('Compensazione: Test dei resuidui standardizzati NON superato\n');
else
    fprintf('Compensazione: Test dei resuidui standardizzati superato\n');

end
