% ELEMENTI DI TOPOGRAFIA E TRATTAMENTO DELLE OSSERVAZIONI
% seconda edizione
% Barzaghi Riccardo, Pinto Livio, Pagliari Diana
% ottobre 2018
% Script realized under BY NC Creative Commons License
% tested for Matlab 2016b

%ESERCIZIO 6.7: LA COMPENSAZIONE DI UNA RETE GPS
%% DATI
clc, clear all, close all

%punto di coordinate note
p1=[1000 1000 10];

% punto_indietro/punto_avanti/deltaX [m]/deltaY [m]/deltaZ [m]
data=[ 1 2 5467.22   288.33 124.56;
       2 3 -881.61  6289.31 -99.59;
       3 4 -3995.9   148.84 -68.72;
       4 1 -589.66 -6726.50  43.77;
       1 3 4585.63  6577.63  24.98;
       4 2 4877.53 -6438.16 168.32];

%precisioni delle basi GPS
sigma0=[0.01 0.01 0.02];


%% POPOLAMENTO MATRICI MQ

sigma02Priori=sigma0(1,1)^2;
%funzione per scrivere la matrice disegno A
A=RiempiA_GPS(data,[2 3 4]);
%vettore delle osservazioni alpha_0
alpha_0=reshape(data(:,3:5).',[],1);
% vettore dei termini noti L
L=Riempi_l_GPS(data,1,p1);
%matrice dei pesi P
P=diag(sigma02Priori./repmat((sigma0).^2,1,6));



%% SOLUZIONE MQ
%matrice normale N
N=A'*P*A;
%termine noto Tn
Tn=A'*P*(alpha_0-L);
% vettore delle incognite x
x=N\Tn;
% x=N\Tn  un metodo pi efficace e stabile in matlab per calcolare
% x=inv(N)*Tn. E' utile sopratutto nel caso di grosse matrici
%vettore delle osservazioni teoriche
alpha=A*x+L;
%vettore degli scarti u
u=alpha_0-A*x-L;
%sigma0^2 posteriori
sigma_02_post=(u'*P*u)/(size(A,1)-size(A,2));
%matrice di varianza e covarianza delle incognite Cxx
Cxx=sigma_02_post*inv(N);
%matrice di varianza e covarianza delle osservazioni C_alpha_alpha
C_alpha_alpha=sigma_02_post*A*inv(N)*A';
%matrice varianza e covarianza degli scarti
C_uu=sigma_02_post*inv(P)-C_alpha_alpha;


%% FUNZIONI
function [ A ] = RiempiA_GPS( data,incognite )
% funzione che scrive la matrice disegno A
% nel caso di una rete GPS
% INPUT
% data: matrice delle osservazioni organizzata come
% punto_indietro/punto_avanti/deltaX [m]/deltaY [m]/deltaZ [m]
% incognite: vettore delle incognite
% OUTPUT
% matrice disegno A

A=zeros(size(data,1)*3,length(incognite)*3);
j=1;
for i=1:3:length(incognite)*3
idx1= find(data(:,1)==incognite(1,j));
A(idx1*3-2,i)=-1;
A(idx1*3-1,i+1)=-1;
A(idx1*3,i+2)=-1;
idx2= find(data(:,2)==incognite(1,j));
A(idx2*3-2,i)=1;
A(idx2*3-1,i+1)=1;
A(idx2*3,i+2)=1;
j=j+1;
end

end


function [ l ] = Riempi_l_GPS( data,pnt_noto,coord_pnt_noto )
% funzione che scrive il vettore dei termini noti L
% nel caso di una rete altimetrica
% INPUT
% data: matrice delle osservazioni organizzata come
% punto_indietro/punto_avanti/deltaX [m]/deltaY [m]/deltaZ [m]
% pnt_noto: vettore dei termini noti
% coord_pnt_noto: coordinate dei punti noti
% OUTPUT
% vettore dei termini noti L


l=zeros(size(data,1)*3,1);
j=1;
for i=1:3:length(pnt_noto)*3
idx1= find(data(:,1)==pnt_noto(1,j));
l(idx1*3-2,1)=-coord_pnt_noto(1);
l(idx1*3-1,1)=-coord_pnt_noto(2);
l(idx1*3,1)=-coord_pnt_noto(3);
idx2= find(data(:,2)==pnt_noto(1,j));
l(idx2*3-2,1)=coord_pnt_noto(1);
l(idx2*3-1,1)=coord_pnt_noto(2);
l(idx2*3,1)=coord_pnt_noto(3);
j=j+1;
end

end

